using System;
using System.Reflection;
namespace Atribuudid3{
   [AttributeUsage(AttributeTargets.Method)]
   class HuvitavMeetodAttribute: System.Attribute{
      private int _kogus;
      private string _koostaja="tundmatu";
      public HuvitavMeetodAttribute(int Ukogus){
         _kogus=Ukogus;
      }
      public int Kogus{
        get{return _kogus;}  
      }
      public string Koostaja{
        get{return _koostaja;}
        set{_koostaja=value;}
      }
   }
   public class ValitudMeetodid{
      [HuvitavMeetodAttribute(3, Koostaja="Jaagup")]
      public void nuputa(){
         Console.WriteLine("Rakendus nuputab");
      }
      [HuvitavMeetodAttribute(1)]
      public void tervita(){
         Console.WriteLine("Tere");
      }
   }
   public class AtribuudiProov{
      public static void Main(string[] arg){
         ValitudMeetodid v=new ValitudMeetodid();
         MethodInfo[] m= typeof(ValitudMeetodid).GetMethods();
         foreach(MethodInfo mi in m){
            MethodAttributes ma=mi.Attributes;
            foreach(Attribute at in Attribute.GetCustomAttributes(mi)){
               if(at.GetType()==typeof(HuvitavMeetodAttribute)){
                 HuvitavMeetodAttribute ha=at as HuvitavMeetodAttribute;
                 for(int i=0; i<ha.Kogus; i++){
                  mi.Invoke(v, null);
                 }            
                 Console.WriteLine("Koostas "+ha.Koostaja); 
                 Console.Write("huvitav ");  
               }
            }
            Console.WriteLine(mi.Name);
         }
      }
   }
}

/*
E:\jaagup\07\12>Atribuudid3
Rakendus nuputab
Rakendus nuputab
Rakendus nuputab
Koostas Jaagup
huvitav nuputa
Tere
Koostas tundmatu
huvitav tervita
GetType
ToString
Equals
GetHashCode
*/
