using System;
public delegate void Sisenemine();

namespace Ilmaandmed{
  public delegate void IlmajaamaTeade(IlmajaamaParameetrid p);
  class Syndmused2{   
   static void HarilikTeave(IlmajaamaParameetrid p){
      Console.WriteLine(p);
   }
   static void HoiatusTeave(IlmajaamaParameetrid p){
      Console.WriteLine("     Hoiatus: "+p);
   }   
   public static void Main(string[] arg){
      Ilmajaam[] jaamad=new Ilmajaam[10];
      for(int i=0; i<jaamad.Length; i++){
         jaamad[i]=new Ilmajaam();
         jaamad[i].tavaTeade+=new IlmajaamaTeade(HarilikTeave);
         jaamad[i].hoiatusTeade+=new IlmajaamaTeade(HoiatusTeave);
      }
      
      string vastus;
      do{
       for(int i=0; i<jaamad.Length; i++){
        jaamad[i].saadaTeated();
       }
       Console.WriteLine("Kas veel?");
       vastus=Console.ReadLine();
      } while(vastus.ToLower().StartsWith("j"));
   }
  }
  
  class Ilmajaam{
   static int jaamadeArv=0;
   int jaamaNr;
   int teateNr=0;
   public event IlmajaamaTeade tavaTeade;
   public event IlmajaamaTeade hoiatusTeade;
   private Random arvugeneraator;
   public Ilmajaam(){
      jaamaNr=++jaamadeArv;
      arvugeneraator=new Random(jaamaNr);
   }
   int kysiTemperatuur(){
      return 15-Math.Abs(6-System.DateTime.Now.Month)*5+arvugeneraator.Next(20);
   }   
   public void saadaTeated(){
      IlmajaamaParameetrid andmed=new IlmajaamaParameetrid(jaamaNr, ++teateNr, kysiTemperatuur());
      tavaTeade(andmed);
      if(andmed.temperatuur<0 || andmed.temperatuur>20){hoiatusTeade(andmed);}
   }
  }
  public class IlmajaamaParameetrid: EventArgs{
     public readonly int temperatuur;
     public readonly int jaamaNr;
     public readonly int teateNr;
     public IlmajaamaParameetrid(int uusJaamaNr, int uusTeateNr, int uusTemperatuur){
        temperatuur=uusTemperatuur;
        jaamaNr=uusJaamaNr;
        teateNr=uusTeateNr;
     }
     public override string ToString(){
        return "Jaam "+jaamaNr+", teade "+teateNr+" temperatuur "+temperatuur;
     }
  }
}
