import java.io.*;
import javax.sound.sampled.*;
public class CDHeli1{
  static AudioFormat formaat;
  static byte[] loe(String failinimi) throws Exception{
    AudioInputStream sisse=AudioSystem.getAudioInputStream(new File(failinimi)); 
    byte[] puhver=new byte[1024];
    formaat=sisse.getFormat();
    System.out.println(formaat);
    ByteArrayOutputStream malu=new ByteArrayOutputStream();
    int kogus=sisse.read(puhver);
    while(kogus!=-1){
        malu.write(puhver, 0, kogus);
        kogus=sisse.read(puhver);
    }
    return malu.toByteArray();  
  }
  static void mangi(byte[] andmed) throws Exception{
    SourceDataLine line=(SourceDataLine)AudioSystem.getLine(
      new DataLine.Info(SourceDataLine.class, formaat, AudioSystem.NOT_SPECIFIED)
    );
    line.open();
    line.start();
    line.write(andmed, 0, andmed.length);
    line.drain();
  }
  static void kirjuta(byte[] andmed, String failinimi) throws Exception{
     AudioInputStream ais=new AudioInputStream(
       new ByteArrayInputStream(andmed), formaat, andmed.length/4
     );
     AudioSystem.write(ais, AudioFileFormat.Type.WAVE, new File(failinimi)); 
  }

  static void trykiEkraanile(byte[] andmed){
    int pikkus=andmed.length/4;
    for(int i=0; i<pikkus; i++){
      System.out.println(loeKvant(andmed, i, 0)+" \t"+loeKvant(andmed, i, 1));
    }
  }

  static int loeKvant(byte[] andmed, int kvant, int kanal){
     int algkoht=kvant*4+kanal*2;
     return  (andmed[algkoht])+ 128*andmed[algkoht+1];
  }

  static void kirjutaKvant(byte[] andmed, int kvant, int kanal, int sisu){
     int algkoht=kvant*4+kanal*2;
     byte b1=(byte)(sisu/128);
     byte b2=(byte)(sisu%128);
     andmed[algkoht+1]=b1;
     andmed[algkoht]=b2;
  }

  static void muudaValjust(byte[] andmed, double koef){
    int pikkus=andmed.length/4;
    for(int i=0; i<pikkus; i++){
      kirjutaKvant(andmed, i, 0, (int)(koef*loeKvant(andmed, i, 0)));
      kirjutaKvant(andmed, i, 1, (int)(koef*loeKvant(andmed, i, 1)));
    }  
  }

  static void nihutaKanalit(byte[] andmed, int nihe){
    int pikkus=andmed.length/4-nihe;
    for(int i=0; i<pikkus; i++){
      kirjutaKvant(andmed, i, 1, loeKvant(andmed, i+nihe, 0));
    }
  }

  public static void main(String[] argumendid) throws Exception{
    byte[] andmed=loe(argumendid[0]);
    muudaValjust(andmed, 0.8);
//   trykiEkraanile(andmed);
//    nihutaKanalit(andmed, 20000);
    kirjuta(andmed, "tulemus.wav");
    mangi(andmed);    
  }
}
