import javax.sound.midi.*;
import java.io.*;
import java.util.*;

/**
* Programm loeb etteantud tekstifailist 
* andmed ning mngib ette vi koostab MIDI-faili.
* Andmed antakse ette astmenimede esithtedena.
* j=jo jne. The taga olev number thistab
* kestust. Numbri puudumisel on tegemist veerandnoodiga
* 1 thendab tervet nooti, 2 poolnooti, 8 
* kaheksandiknooti ning 6 kuueteistkmnendiknooti.
* # ja b on krgendus- ja madaldusmrk.
* Noodi jrel lisatud lakoma' nitab noodi
* kuulumist krgemasse oktaavi, koma, aga madalamasse
* oktaavi.
* Jo asukohta saab mrata kirjutades rea algusse niteks
* jo=C  , mis thendab kindlaksmratud krgust
* jo=60 on sama MIDI numbrina
* jo=+2 thendab loo krgendamist terve tooni
* ehk kahe pooltooni vrra, 
* jo=-1 aga madaldamist he pooltooni jagu.
* Kommentaariks loetakse real asuvast semikoolonist
* edasi asetsev tekst.
*/
public class Noodilugeja1{
 static Sequence sekvents;
 static Track rada;
 static int tiks=0;
 static int toonika=60;
 static int valjus=90;
 static int pill=16;
 static int[] noodivahed={0, 2, 4, 5, 7, 9, 11}; //Kaugused toonikast pooltoonides
 static char[] tahised={'j','l','m','n','s','r','d'}; //jo, le, mi, na, so, ra, di
 static int[] noodipikkused={16, 8, 4, 2, 1}; //Noodi pikkus tiksudes
 static int[] pikkustahised={'1', '2', '4', '8', '6'}; //Pikkusele vastav smbol
 static int[] tahtnimetused={'c', 'd', 'e','f','g','a','h'}; 
 static void alusta() throws InvalidMidiDataException{
   sekvents=new Sequence(Sequence.PPQ, 4);
   sekvents.createTrack(); //algusesse thi rada
   rada=sekvents.createTrack();
   ShortMessage algus=new ShortMessage();
   algus.setMessage(ShortMessage.PROGRAM_CHANGE, 0, pill,0);
   rada.add(new MidiEvent(algus, 0));
 }
 static void lisaNoot(String s) throws InvalidMidiDataException{
   int pikkus=4;
   int nihe=-1; //kaugus toonikast.
   boolean paus=true;
   int koht=0;  //Mitmenda smbolini ollakse analsil jutud
   for(int i=0; i<tahised.length; i++){
     if(tahised[i]==s.charAt(0)){
        nihe=noodivahed[i];
        paus=false;
     }
   }
   koht++;
   //Vastavalt thisele noodi pikkus
   //Kui pole mrgitud, siis jb helgiline ehk nelja tiksuga veerandnoot
   if(s.length()>koht){ 
     char tahis=s.charAt(koht);
     for(int i=0; i<noodipikkused.length; i++){
       if(pikkustahised[i]==tahis){
         pikkus=noodipikkused[i];
         koht++;
       }
     }
   }
   if(s.length()>koht){
     if(s.charAt(koht)=='.'){
       pikkus=pikkus+pikkus/2;
       koht++;
     }
   }
   
   //Krgendus/madaldus  
   if(s.length()>koht){
    if(!paus){ 
     char tahis=s.charAt(koht);
     if(tahis=='#'){
       nihe++; koht++; 
     }
     if(tahis=='b'){
       nihe--; koht++; 
     }
    }
   }
   //Nihe oktaavides
   while(s.length()>koht){
     char tahis=s.charAt(koht);
     if(tahis=='\''){nihe+=12;} //oktaav les
     if(tahis==','){nihe-=12; } //oktaav alla
     koht++;
   }
   int korgus=toonika+nihe;
   if(!paus){
     ShortMessage lahti=new ShortMessage();
     lahti.setMessage(ShortMessage.NOTE_ON, 0, korgus, valjus);
     rada.add(new MidiEvent(lahti, tiks));     
   }
   tiks+=pikkus;
   if(!paus){
     ShortMessage kinni=new ShortMessage();
     kinni.setMessage(ShortMessage.NOTE_OFF, 0, korgus, valjus);
     rada.add(new MidiEvent(kinni, tiks));     
   }
 }

 static void muudaJo(String s){
   int muutus=-1;
   for(int i=0; i<tahtnimetused.length; i++){
      if(s.charAt(0)==tahtnimetused[i]){
        muutus=noodivahed[i];
      }
   }
   if(muutus!=-1){
     toonika=60+muutus; //60 on C helikrgus
     return;
   }
   //plussi vi miinusega muudetakse toonikat mratud arv pooltoone
   if(s.charAt(0)=='+'){toonika+=Integer.parseInt(s.substring(1)); return;}
   if(s.charAt(0)=='-'){toonika+=Integer.parseInt(s.substring(1)); return;}
   toonika=Integer.parseInt(s);
 }

 static void loeFail(String failinimi) throws IOException, InvalidMidiDataException{
   BufferedReader sisse=new BufferedReader(new FileReader(failinimi));
   for(String rida=sisse.readLine(); rida!=null; rida=sisse.readLine()){
     //semikoolonist alates kommentaar
     if(rida.indexOf(";")>=0){rida=rida.substring(0, rida.indexOf(";"));}
     rida=rida.toLowerCase();
     if(rida.length()>3 && rida.startsWith("jo=")){
       muudaJo(rida.substring(3));
       continue;
     }
     StringTokenizer stk=new StringTokenizer(rida);
     while(stk.hasMoreTokens()){
       lisaNoot(stk.nextToken());
     }
   }
   sisse.close();
 }
 
 static void trykiFail(String failinimi) throws IOException{
   MidiSystem.write(sekvents, 1, new FileOutputStream(failinimi));
 }
 
 static void mangi() throws Exception{
   Sequencer sekventser=MidiSystem.getSequencer();
   sekventser.open();
   sekventser.setSequence(sekvents);
   sekventser.start();
 }
 
 public static void main(String argumendid[]) throws Exception{
   if(argumendid.length==0){
     System.out.println("Kasuta kujul ");
     System.out.println("java Noodilugeja1 sisendfail.txt [valjundfail.mid]");
     return;
   }
   alusta();
   loeFail(argumendid[0]);
   if(argumendid.length>1){trykiFail(argumendid[1]);}
   else {mangi();}
 }
}
