import javax.sound.midi.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Noodirakend10 extends JApplet implements ActionListener, MetaEventListener{
  Sequence sequence;
  Sequencer sequencer;
  JButton nupp=new JButton("Mngi");
  JCheckBox ruut=new JCheckBox("Jtka");
  JCheckBox bass=new JCheckBox("Bass");
  JCheckBox akord=new JCheckBox("Akord");
  JCheckBox taust=new JCheckBox("Taust");
  JComboBox helistik=new JComboBox();
  JRadioButton[] raadionupud=new JRadioButton[3];
  String[] raadionupustring={"I", "IV", "V"};
  JScrollBar tempo=new JScrollBar(JScrollBar.HORIZONTAL, 190, 5, 40, 320);
  int meloodiavaljus=70;
  int bassivaljus=60;
  int saatevaljus=60;
  int viiulivaljus=60;
  JScrollBar sbMeloodia=new JScrollBar(JScrollBar.HORIZONTAL, meloodiavaljus, 5, 0, 127);
  JScrollBar sbBass=new JScrollBar(JScrollBar.HORIZONTAL, bassivaljus, 5, 0, 127);
  JScrollBar sbSaade=new JScrollBar(JScrollBar.HORIZONTAL, saatevaljus, 5, 0, 127);
  JScrollBar sbViiul=new JScrollBar(JScrollBar.HORIZONTAL, viiulivaljus, 5, 0, 127);
  Track muutuvRada;
  Track meloodiarada; //kuhu kogu meloodia loetud on
  Track meloodiaManguRada; //rada konkreetse takti mngimiseks
  String[] helistikud={"Bb", "F", "C", "G", "D", "A", "E"};
  int[] helikorgused={58, 53, 60, 55, 50, 57, 52};
  String jooksevHelistik="";
  static final int[] noodivahed={-1, 0, 2, 4, 5, 7, 9, 11, 12};  //toonika kohal 1 vrtus 0
  int[] duurid={
        0, 0, //eeltaktid
        0, 1, 2, 0, 1, 2, 0, 0,
        0, 1, 2, 0, 1, 2, 0, 0,
        0, 1, 2, 0, 1, 2, 0, 0  
     };  // Juhansonide uneno laul
                                          // 0- toonika, 1-IV, 2-V
  int taktinr=0; //takti jrjekorranumber
  int taktipikkus=12; //3 lki * 4 tiksu lgi kohta 
  void looKolmkola(Track t, int toonika){
  try{
   ShortMessage m[]=new ShortMessage[7];
   for(int i=0; i<m.length; i++){
     m[i]=new ShortMessage();  		// Thjad teated valmis
   }  
   m[0].setMessage(ShortMessage.PROGRAM_CHANGE, 0, 25, 0);  //pill nr 25 rajale 0
   m[1].setMessage(ShortMessage.NOTE_ON, 0, toonika, saatevaljus);
   m[2].setMessage(ShortMessage.NOTE_ON, 0, toonika+4, saatevaljus); //terts rajale 0 valjusega 60
   m[3].setMessage(ShortMessage.NOTE_ON, 0, toonika+7, saatevaljus); //kvint
   m[4].setMessage(ShortMessage.NOTE_OFF, 0, toonika, saatevaljus);
   m[5].setMessage(ShortMessage.NOTE_OFF, 0, toonika+4, saatevaljus);
   m[6].setMessage(ShortMessage.NOTE_OFF, 0, toonika+7, saatevaljus);
    t.add(new MidiEvent(m[0], 0));
   for(int i=1; i<4; i++){
     t.add(new MidiEvent(m[i], (i-1)*4));  // nelja tiksu (he lgi) tagant
   }                                       // noodid sisse
   for(int i=4; i<7; i++){
     t.add(new MidiEvent(m[i], 12));       // 12nda tiksu juures vaikus
   }
  }catch(Exception e){
    e.printStackTrace();
  }
 }
  
  
 void looBass(Track t, int toonika){
  try{
   ShortMessage m[]=new ShortMessage[3];
   for(int i=0; i<m.length; i++){
     m[i]=new ShortMessage();  
   }  
   m[0].setMessage(ShortMessage.PROGRAM_CHANGE, 1, 39, 0); 
   m[1].setMessage(ShortMessage.NOTE_ON, 1, toonika-24, bassivaljus); 
   m[2].setMessage(ShortMessage.NOTE_OFF, 1, toonika-24, bassivaljus); 
   t.add(new MidiEvent(m[0], 0));
   t.add(new MidiEvent(m[1], 0));
   t.add(new MidiEvent(m[2], 12));
  }catch(Exception e){e.printStackTrace();}
 }
 
 static int pooltoonid(int aste, int muutus){
    int loppaste=aste+muutus;
    int okt=loppaste/7;
    if(loppaste<0)okt--;
    loppaste=loppaste-7*okt;
    int vahe=noodivahed[loppaste]-noodivahed[aste];
    return vahe+12*okt;
 }

 void looTaustaviiul(Track t, int toonika, int aste){
  try{
   int nootidearv=6;
   int[] samm=new int[nootidearv];
   int i=0;  
   samm[i++]=0;
   while(i<nootidearv){
     if(Math.random()<0.5){
       samm[i]=samm[i-1]-1;
     } else {
       samm[i]=samm[i-1]+1;     
     }
     i++;
   }
   ShortMessage m=new ShortMessage();
   m.setMessage(ShortMessage.PROGRAM_CHANGE, 2, 41, 0);
   t.add(new MidiEvent(m, 0));
   for(i=0; i<nootidearv; i++){
     m=new ShortMessage();
     m.setMessage(ShortMessage.NOTE_ON, 2, toonika+noodivahed[aste]+pooltoonid(aste, samm[i]), viiulivaljus);
     t.add(new MidiEvent(m, i*2));
     m=new ShortMessage();
     m.setMessage(ShortMessage.NOTE_OFF, 2, toonika+noodivahed[aste]+pooltoonid(aste, samm[i]), viiulivaljus);
     t.add(new MidiEvent(m, (i+1)*2));
   }
  }catch(Exception e){e.printStackTrace();}
 }

 void kopeeriMeloodia(Track t, int toonika){
  try{
   int algus=taktipikkus*taktinr;
   int ots=taktipikkus*(taktinr+1);
   int nihe=toonika-60; //Eeldades, et algne lugu on C-duuris
   for(int i=0; i<meloodiarada.size(); i++){
     MidiEvent me=meloodiarada.get(i);
     if(me.getTick()>=algus && me.getTick()<ots){  //kui noot asub mngitavas taktis
      if(me.getMessage() instanceof ShortMessage){
        ShortMessage sm=(ShortMessage)me.getMessage();
        ShortMessage sm2=new ShortMessage();
        if(sm.getCommand()==ShortMessage.NOTE_ON ||
             sm.getCommand()==ShortMessage.NOTE_OFF){
          sm2.setMessage(
            sm.getCommand(), sm.getChannel(), sm.getData1()+nihe, meloodiavaljus
          );
        } else {
          sm2=(ShortMessage)sm.clone();
        }
        t.add(new MidiEvent(sm2, me.getTick()-algus));
      }
     }
   }
  }catch(Exception e){e.printStackTrace();}

 }

 Sequence pohikolmkolad(int toonika) throws InvalidMidiDataException{
   Sequence s1=new Sequence(Sequence.PPQ, 4);  
   looKolmkola(s1.createTrack(), toonika);
   looKolmkola(s1.createTrack(), toonika+5); //kvart
   looKolmkola(s1.createTrack(), toonika+7); //kvint
   looBass(s1.createTrack(), toonika);
   looBass(s1.createTrack(), toonika-7); //IV ehk kvint alla
   looBass(s1.createTrack(), toonika-5); 
   return s1;
 }
 
 Sequence looSekvents() throws InvalidMidiDataException{
   return pohikolmkolad(helikorgused[helistik.getSelectedIndex()]);
 }
  
 void paneSoolo(){
   for(int i=0; i<raadionupud.length; i++){
     sequencer.setTrackMute(i, !raadionupud[i].isSelected());
     sequencer.setTrackMute(3+i, !raadionupud[i].isSelected());
   }  
 }
  
 void mangi(){
   sequencer.setMicrosecondPosition(0);
   sequencer.start();
   paneSoolo();
   sequencer.setTempoInBPM(tempo.getValue());
  
 }
 
 void alusta(){
  try{
   sequence=looSekvents();
   jooksevHelistik=helistik.getSelectedItem().toString();
   meloodiavaljus=sbMeloodia.getValue();
   saatevaljus=sbSaade.getValue();
   bassivaljus=sbBass.getValue();
   viiulivaljus=sbViiul.getValue();
   muutuvRada=sequence.createTrack();
   meloodiaManguRada=sequence.createTrack();
   int pohitoon=helikorgused[helistik.getSelectedIndex()];  
   int aste=1;
   if (duurid[taktinr]==1)aste=4;
   if (duurid[taktinr]==2)aste=5;
   looTaustaviiul(muutuvRada, pohitoon, aste);
   kopeeriMeloodia(meloodiaManguRada, pohitoon);
   sequencer.setSequence(sequence);
   raadionupud[duurid[taktinr]].setSelected(true);
   taktinr=(taktinr+1)%duurid.length;
   mangi();
  }catch(Exception e){e.printStackTrace();}
 }
 
 public void init(){
      Panel nupupaneel=new Panel(new GridLayout(1, 4));
      helistik=new JComboBox(helistikud);
      helistik.setSelectedIndex(3);
      nupupaneel.add(helistik);
      ButtonGroup nupugrupp=new ButtonGroup();
      for(int i=0; i<raadionupud.length; i++){
        raadionupud[i]=new JRadioButton(raadionupustring[i]);
        nupugrupp.add(raadionupud[i]);
        nupupaneel.add(raadionupud[i]);
      }
      raadionupud[0].setSelected(true);
      ruut.setSelected(true);
      JPanel ribapaneel=new JPanel(new GridLayout(6, 2));
      ribapaneel.add(new JLabel("Tempo:"));
      ribapaneel.add(tempo);
      ribapaneel.add(new JLabel("Meloodia:"));
      ribapaneel.add(sbMeloodia);
      ribapaneel.add(new JLabel("Akord:"));
      ribapaneel.add(sbSaade);
      ribapaneel.add(new JLabel("Bass:"));
      ribapaneel.add(sbBass);
      ribapaneel.add(new JLabel("Viiul:"));
      ribapaneel.add(sbViiul);
      ribapaneel.add(nupp);
      ribapaneel.add(ruut);
      getContentPane().add(ribapaneel, BorderLayout.SOUTH);
      getContentPane().add(nupupaneel, BorderLayout.NORTH);
      nupp.addActionListener(this);
      Sequence partituur=null;
      try{
        partituur=MidiSystem.getSequence(new java.io.File("unenagu.mid")); 
      }catch(Exception ex){
        try{
          partituur=MidiSystem.getSequence(new java.net.URL(getCodeBase()+"unenagu.mid"));
        }catch(Exception e){e.printStackTrace();}
      }
      meloodiarada=partituur.getTracks()[1];

 }
 
  public void stop(){
    ruut.setSelected(false);
    //veebilehelt lahkumisel lpetatakse mngimine
  }
 

  public void actionPerformed(ActionEvent e){
   try{
         sequencer=MidiSystem.getSequencer();
         sequencer.open();
         sequencer.addMetaEventListener(this);
         jooksevHelistik="";
         alusta();
   }catch(Exception ex){
     ex.printStackTrace();
     System.out.println(ex);
   }
  }
  
  public void meta(MetaMessage m){
    if(m.getType()==47 && ruut.isSelected()){
      alusta();
    } else {
      sequencer.close();
    }
  }
  public static void main(String argumendid[]){
    JFrame f=new JFrame("Saade");
    Noodirakend10 ap=new Noodirakend10();
    ap.init();
    f.getContentPane().add(ap);
    f.pack();
    f.setVisible(true);
    f.addWindowListener(
      new WindowAdapter(){
        public void windowClosing(WindowEvent e){
          System.exit(0);
        }
      }
    );
  }

    
}
